#!/bin/csh
# usage : MB.rmsd_2d.CC Nx1 Ny1 {Nx2 Ny2} {Dx1 Dy1 Dx2 Dy2}
# usage : MB.rmsd_3d.CC Nx1 Ny1 Nz1 {Nx2 Ny2 Nz2} {Dx1 Dy1 Dz1 Dx2 Dy2 Dz2}
#
@ dim = `basename $0 | tr -d 'MB.rmsd_C'`
set usage=('unknown command.' \
           'MB.rmsd_2d.CC Nx1 Ny1 {Nx2 Ny2} {Dx1 Dy1 Dx2 Dy2}' \
           'MB.rmsd_3d.CC Nx1 Ny1 Nz1 {Nx2 Ny2 Nz2} {Dx1 Dy1 Dz1 Dx2 Dy2 Dz2}')
set unit='8/(1024*1024)'
#
@ div = $#argv / $dim ; @ tmp = $#argv % $dim
if ($div !~ [1-4] || $tmp != 0) then
  echo echo usage : "'${usage[$dim]}'" '1>&2' | /bin/sh ; exit 1
endif
#
set L=2 ; set M='' ; @ coo = 0
while ($coo < $dim)
  @ coo += 1
#
  @ N1 = $argv[$coo]
  if ($div =~ [1,3]) then
    @ N2 = $N1
  else
    @ tmp = $dim + $coo ; @ N2 = $argv[$tmp]
  endif
  if ($N1 <= 0 || $N2 <= 0) then
    echo echo bad image size. '1>&2' | /bin/sh ; exit 1
  endif
#
  if ($div =~ [1,2]) then
    @ D1 = 1 - $N2
    @ D2 = $N1 - 1
  else
    @ tmp = ( ( $div - 2 ) * $dim ) + $coo ; @ D1 = $argv[$tmp]
    @ tmp = ( ( $div - 1 ) * $dim ) + $coo ; @ D2 = $argv[$tmp]
  endif
  @ tmp = - $N2
  if ($D1 > $D2 || $D1 <= $tmp || $D2 >= $N1) then
    echo echo bad range of distance. '1>&2' | /bin/sh ; exit 1
  endif
#
  @ m = ( $D2 - $D1 ) + 1 ; set M=($M $m)
#
  @ n1 = $N2 + $D2 ; if ($n1 > $N1) @ n1 = $N1
  @ n2 = $N1 - $D1 ; if ($n2 > $N2) @ n2 = $N2
  if ($D2 < 0) then
    @ n = $n2 + $D2 ; if ($n < $n1) @ n = $n1
    @ d = $D2 - $D1
  else if ($D1 > 0) then
    @ n = $n1 - $D1 ; if ($n < $n2) @ n = $n2
    @ d = $D2 - $D1
  else
    @ n = $n1 ; if ($n < $n2) @ n = $n2
    @ d = - $D1 ; if ($d < $D2) @ d = $D2
  endif
  @ nd = $n + ( $d + 1 ) ; set L=($L 1)
  while ($nd > $L[$#L])
    @ L[$#L] *= 2
  end
end
( echo -n "(${M}+${L})" | tr ' ' \* ; echo "*$unit" ) #| bc
