
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

static void	Range(Ng,Nh,D,Og,Oh,N)
int		Ng,Nh,D,*Og,*Oh,*N;
{
	if (D<0) {
	    *Og=0; *Oh=(-D); if ((*N=Nh+D)>Ng) *N=Ng;
	}
	else {
	    *Og=D; *Oh=0; if ((*N=Ng-D)>Nh) *N=Nh;
	}
}

#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Ngx,Ngy,Nhx,Nhy,Dx,Dy,BPS,xg,xh,Nx,yg,yh,Ny,y,x;
	Cell	**G,**H;
	double	Bgh,Sg,Sh,base,step,roof,gh,min,max;
	char	desc[LEN];

	if (argc!=11 && argc!=13)
	    Error(
"usage : sub_2d TIFF1 base1 step1 TIFF2 base2 step2 Dx Dy {base step} BPS TIFF"
	    );

	ReadImageFile(argv[1],&Ngx,&Ngy,NULL,&G,NULL);
	ReadImageFile(argv[4],&Nhx,&Nhy,NULL,&H,NULL);

	Bgh=atof(argv[2])-atof(argv[5]);
	Sg=atof(argv[3]);
	Sh=atof(argv[6]);

	if ((Dx=atoi(argv[7]))<=(-Nhx) || Dx>=Ngx ||
	    (Dy=atoi(argv[8]))<=(-Nhy) || Dy>=Ngy) Error("bad distance.");

	if ((BPS=atoi(argv[argc-2]))<1 || BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (argc==13) {
	    if ((step=atof(argv[10]))<=0.0) Error("bad step.");

	    base=atof(argv[9]); roof=base+step*(double)((1<<BPS)-1);
        }
	Range(Ngx,Nhx,Dx,&xg,&xh,&Nx);
	Range(Ngy,Nhy,Dy,&yg,&yh,&Ny);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    gh=Bgh+Sg*(double)G[y+yg][x+xg]-Sh*(double)H[y+yh][x+xh];

	    if (x==0 && y==0)
		min=max=gh;
	    else
		if (gh<min) min=gh; else if (gh>max) max=gh;
	}
	if (argc==11) {
	    if (min==max) (void)fputs("no value range (warning).\n",stderr);

	    step=(max-min)/(double)((1<<BPS)-1); base=min; roof=max;
	}
	(void)sprintf(desc,"%lf\t%lf\t%lf\t%18.16lf",min,max,base,step);
	(void)puts(desc);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    gh=Bgh+Sg*(double)G[y+yg][x+xg]-Sh*(double)H[y+yh][x+xh];

	    G[y][x]=(gh<=base)?0:
		    (gh>=roof)?(Cell)((1<<BPS)-1):(Cell)((gh-base)/step+0.5);
	}
	StoreImageFile(argv[argc-1],Nx,Ny,BPS,G,desc);

	return 0;
}
