
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

extern void	Error();

typedef struct {
		int	i;
		double	d;
	} Sum;

#define ALLOC(type,size)	(type *)malloc((size_t)(size)*sizeof(type))

int	main(argc,argv)
int	argc;
char	**argv;
{
	double	Bx,By,Sx,Sy,Rx,Ry,X,Y,V,x1,x2,y1,y2,v1,v2,none,base,step,roof;
	int	Nx,Ny,y,x,BPS,No=0;
	Sum	**sum;
	Cell	**cell;
	char	*mae="memory allocation error.";

	if (argc!=10 && argc!=12)
	    Error("usage : xyv2t Bx By Sx Sy Nx Ny none {base step} BPS TIFF");

	Bx=atof(argv[1]);
	By=atof(argv[2]);

	if ((Sx=atof(argv[3]))<=0.0 ||
	    (Sy=atof(argv[4]))<=0.0) Error("bad pixel size.");

	if ((Nx=atoi(argv[5]))<=0 ||
	    (Ny=atoi(argv[6]))<=0) Error("bad pixel number.");

	if ((cell=(Cell **)(sum=ALLOC(Sum *,Ny)))==NULL) Error(mae);

	for (y=0; y<Ny; y++) {
	    if ((sum[y]=ALLOC(Sum,Nx))==NULL) Error(mae);

	    for (x=0; x<Nx; x++) sum[y][x].d=(double)(sum[y][x].i=0);
	}
	Bx-=(Sx/2.0); Rx=Bx+Sx*(double)Nx;
	By-=(Sy/2.0); Ry=By+Sy*(double)Ny;

	while (scanf("%lf %lf %lf",&X,&Y,&V)==3) {
	    if (X>=Bx && X<Rx && Y>=By && Y<Ry) {
		x=(int)((X-Bx)/Sx);
		y=(int)((Y-By)/Sy); ++sum[y][x].i; sum[y][x].d+=V;
	    }
	    if (++No==1) {
		x1=x2=X; y1=y2=Y; v1=v2=V;
	    }
	    else {
		if (X<x1) x1=X; else if (X>x2) x2=X;
		if (Y<y1) y1=Y; else if (Y>y2) y2=Y;
		if (V<v1) v1=V; else if (V>v2) v2=V;
	    }
	}
	if (No==0) Error("no data.");

	printf("%lf\t%lf\n%lf\t%lf\n%lf\t%lf\n",x1,x2,y1,y2,v1,v2);

	if ((BPS=atoi(argv[argc-2]))<1 || BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (argc==10) {
	    if (v1==v2) fputs("no value range (warning).\n",stderr);

	    step=(v2-v1)/(double)((1<<BPS)-1); base=v1; roof=v2;
	}
	else {
	    if ((step=atof(argv[9]))<=0.0) Error("bad step.");

	    base=atof(argv[8]); roof=base+step*(double)((1<<BPS)-1);
	}
	none=atof(argv[7]);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    V=(sum[y][x].i)?sum[y][x].d/(double)sum[y][x].i:none;

	    cell[y][x]=(V<=base)?0:
		       (V>=roof)?(Cell)((1<<BPS)-1):(Cell)((V-base)/step+0.5);
	}
	StoreImageFile(argv[argc-1],Nx,Ny,BPS,cell,NULL);

	return 0;
}
